from typing import List, Dict, Any, TypedDict, Optional


Record = Dict[str, Any]
SearchRecords = List[Record]


class SearchResult(TypedDict):
    all: SearchRecords
    first: Optional[Record]
    last: Optional[Record]
    total: int


def search_result(results: Optional[SearchRecords]) -> SearchResult:
    total = len(results)
    first, last = list(map(lambda i: results[i], {0, -1})) if total > 0 else [None, None]
    return SearchResult(all=results, first=first, last=last, total=total)
